# -*- coding:Utf-8 -*-
import es, time, psyco, effectlib, cfglib, playerlib
psyco.full()

config = cfglib.AddonCFG(es.getAddonPath("dynamite") + "/dynamite.cfg")

config.text("******************************")
config.text("  Dynamite SETTINGS")
config.text("******************************")

dy_rayon  = config.cvar("dy_rayon",  600, "Rayon de l'explosion. Defaut: 600")
dy_circle = config.cvar("dy_circle",  1, "1 = Active le marquage de la dynamite par un cercle rouge de rayon 50u")
config.write()

info = es.AddonInfo()
info.version = '1'
es.ServerVar('dynamite', info.version, 'Dynamite  | by @liVier ').makepublic()

players = {}

def load():
	es.mexec('../addons/eventscripts/dynamite/dynamite.cfg')
	es.msg("#multi", "#green Dynamite Module-v1#default by @liVier#lightgreen On !:")
	es.doblock('corelib/noisy_on')
	
def unload():
	es.msg("#multi", "#green Dynamite Module-v1#default by @liVier#lightgreen Off !:")
	es.doblock('corelib/noisy_off')

def player_activate(ev):
	es.tell(ev['userid'], "#multi", "#green [Dynamite]#lightgreen La hegrenade est une dynamite, elle causera des dommages retardes dans un rayon de#default %iu" % dy_rayon)
	players[int(ev['userid'])] = {}
	
def player_disconnect(ev):
	del players[int(ev['userid'])]
	
def round_end(ev):
	es.server.insertcmd("es_xfire 0 env_physexplosion Kill")	

def grenade_bounce(ev):
	userid = int(ev['userid'])
	o = es.createvectorstring(ev['x'], ev['y'], ev['z'])
	for index in es.createentityindexlist():
		if es.getindexprop(index, 'CBaseEntity.m_vecOrigin') != o:
			continue
		gname = es.entitygetvalue(index, 'ClassName')[0:7]
		gindex = index
	if gname == 'hegrena':
		es.server.insertcmd("es_xremove %s" % gindex)
		circletime = 30 - players[int(userid)]*10
		players[int(userid)] = 30 - players[int(userid)]*10
		if players[userid] < 10: players[userid] = 10
		deflag_index = es.createentity("env_physexplosion", ("env_physexplosion_" + str(userid)))
		es.entitysetvalue(deflag_index, 'origin', '%s %s %s' %(ev['x'],ev['y'],ev['z']))
		explose(userid, deflag_index, index, players[userid])
		if circletime + 3 > 32: circletime = 32
		if dy_circle == 1: effectlib.drawCircle((ev['x'], ev['y'], str(float(ev['z']) + 40)), radius=50, steps=60, model="materials/sprites/laser.vmt", halo="materials/sprites/halo01.vmt",
		seconds= circletime + 3, width=10, endwidth=10, red=255, green=0, blue=0, brightness=255, speed=100)
		
def explose(userid, index, index1, dtime):
   user = playerlib.getPlayer(userid)
   origin = es.entitygetvalue(index, 'origin')
   outputs = {
      "Radius"    : dy_rayon,
      "Magnitude" : 500,
      "SpawnFlags": 32,
      "Origin"    : origin
      }
   for output in outputs:
	  es.entitysetvalue(index, output, outputs[output])	  
   
   if int(user.team) == 2:
		for playert in playerlib.getPlayerList("#t"):
			es.tell(playert.userid, "#multi", "#green [Dynamite]#default [%s]#lightgreen Explosion dans#default %s secondes !" % (user.name,dtime))
   if int(user.team) == 3:	
		for playerct in playerlib.getPlayerList("#ct"):
			es.tell(playerct.userid, "#multi", "#green [Dynamite]#default [%s]#lightgreen Explosion dans#default %s secondes !" % (user.name,dtime))
			
   es.fire(userid, ("env_physexplosion_" + str(userid)), "Explode", None, dtime)
   es.fire(userid, ("env_physexplosion_" + str(userid)), "Kill", None, dtime)
   
 	
def client_keypress(ev):
	userid = int(ev['userid'])
	if ev['keyname'] == 'attack' and ev['es_userweapon'] == 'weapon_hegrenade':
		if int(ev['status']):
			players[userid] = time.time()
		elif userid in players:
			players[userid] = (int(time.time()) - int(players[userid]))/2